#!/usr/bin/python
#-*- coding: utf-8 -*-

#from __future__ import unicode_literals

import requests
import csv

# lib XML
from lxml import etree



#############################################################################################################################
###################################           BUILD XML ARTICLE CONF POSTER OUV COUV
# CREATION XML pour articles, conferences et posters, ouvrage et chapitres d'ouvrage
#############################################################################################################################
#############################################################################################################################

def createXml_sendHal(numero,listauthors, lang_title, title_publi, name_conf, nb_pages, date_pub, listdomains, type_pub, ville, pays, pays_acr, doi_value, editor_book, volume, pubmed, name_user, labo_auth_final, id_hal_user, login_user, login_depot, passwd_depot, bool_depot_preprod, bool_depot_prod):
    print ("method createXml_sendHal begin")
    ## VARIABLES CREATION XML

    # Recup des donnes de la liste
    namefile = "xml_files/"+login_depot+str(numero)+".xml"

    file = open(namefile,"w") 
    file.write("<?xml version=\"1.0\" encoding=\"utf-8\"?>\n")


    tei = etree.Element("TEI")
    tei.set("xmlns","http://www.tei-c.org/ns/1.0")
    tei.set("xmlns_hal","http://hal.archives-ouvertes.fr/")   ### ATTENTION   remplacement xmlns_hal par xmlns:hal

    text = etree.SubElement(tei, "text")
    body = etree.SubElement(text, "body")
    listBibl = etree.SubElement(body, "listBibl")
    biblFull = etree.SubElement(listBibl, "biblFull")

    # TitleStmt
    if (type_pub == "COMM") or (type_pub == "POSTER") or  (type_pub == "ART") or (type_pub == "OUV") or  (type_pub == "COUV")  :

        titleStmt = etree.SubElement(biblFull, "titleStmt")
        title = etree.SubElement(titleStmt, "title")
        title.set("xml_lang",lang_title)          #Build from data      ### ATTENTION  remplacement xml_lang par xml:lang

        
        title.text = title_publi.decode("utf-8")                 #Build from data


        #print ("CREATE XML title "+str(type(title_publi))+ " title UTF8 "+title_publi.decode("utf-8")+str(type(title_publi.decode("utf-8"))))
        ## TEST
        print ("createXML, id_hal user ",id_hal_user)

        for auth in listauthors :
            author = etree.SubElement(titleStmt, "author")
            author.set("role","aut")
            persName = etree.SubElement(author, "persName")
            forename = etree.SubElement(persName, "forename")
            forename.set("type","first")
            #print ("Author "+auth[1] + " "+auth[0])
            prenom_auth = auth[1].decode("utf-8")
            forename.text = prenom_auth                #Build from data
            surname = etree.SubElement(persName, "surname")
            nom_auth = auth[0].decode("utf-8")
            surname.text = nom_auth     
            print ("AUTH 2 ", auth[0],auth[1],auth[2])                #Build from data
            if len(auth[2]) > 1 :
                if auth[0].decode('utf-8') == name_user and id_hal_user is not "" :
                    idno =  etree.SubElement(author, "idno")
                    idno.set("type", "idhal")
                    idno.text = id_hal_user
                affiliation = etree.SubElement(author, "affiliation")
                labo_author = "#"+auth[2]
                affiliation.set("ref",labo_author)             #Build from data



    # Unnecessary noteStmt
    """
    notesStmt = etree.SubElement(biblFull, "notesStmt")
    note = etree.SubElement(notesStmt, "note")
    note.set("type","commentary")
    note.text = comment_publi
    """
    # sourceDesc
    sourceDesc = etree.SubElement(biblFull, "sourceDesc")
    biblStruct = etree.SubElement(sourceDesc, "biblStruct")
    analytic = etree.SubElement(biblStruct, "analytic")
    title = etree.SubElement(analytic, "title")
    title.set("xml_lang",lang_title)          #Build from data             ### ATTENTION remplacement  xml_lang par xml:lang
    title.text = title_publi.decode("utf-8")                  #Build from data

    for auth in listauthors :
        author = etree.SubElement(analytic, "author")
        author.set("role","aut")
        persName = etree.SubElement(author, "persName")
        forename = etree.SubElement(persName, "forename")
        forename.set("type","first")
        forename.text = auth[1].decode("utf-8")                #Build from data
        surname = etree.SubElement(persName, "surname")
        surname.text = auth[0].decode("utf-8")                    #Build from data
        if len(auth[2]) > 1 :
            if auth[0].decode("utf-8") == name_user and id_hal_user is not "":
                idno =  etree.SubElement(author, "idno")
                idno.set("type", "idhal")
                idno.text = id_hal_user
            affiliation = etree.SubElement(author, "affiliation")
            labo_author = "#"+auth[2]
            affiliation.set("ref",labo_author)             #Build from data


    monogr = etree.SubElement(biblStruct, "monogr")
    title = etree.SubElement(monogr, "title")
    if type_pub == "ART":
        title.set("level","j")
        title.text = name_conf.decode("utf-8")                      #Build from data
    if type_pub == "COMM":
        title.set("level","m")
        title.text = name_conf.decode("utf-8")                   #Build from data
    if type_pub == "POSTER":
        title.set("level","m")
        title.text = name_conf.decode("utf-8")    
    # Pour les COUV on donne le titre du livre (ici noté name_conf)
    if type_pub == "COUV":
        title = etree.SubElement(monogr, "title")
        title.set("level","m")
        title.text = name_conf.decode("utf-8")   # ici name_conf = titre livre                    #Build from data
        if len(editor_book) > 0 :
            editor = etree.SubElement(monogr, "editor")
            editor.text = editor_book.decode("utf-8")     #Build from data

    
    if (type_pub == "COMM") or (type_pub == "POSTER") :
        if (pays.strip() is not ""):
    
            meeting = etree.SubElement(monogr, "meeting")
            title = etree.SubElement(meeting, "title")
            title.text = name_conf.decode("utf-8")                    #Build from data

            date = etree.SubElement(meeting, "date")
            date.set("type","start")
            date.text = date_pub
            settlement = etree.SubElement(meeting, "settlement")
            settlement.text = ville.decode("utf-8")
            country = etree.SubElement(meeting, "country")
            country.set("key",pays_acr)
            country.text = pays#.decode("utf-8")
    
    imprint = etree.SubElement(monogr, "imprint")
    
    if len(volume) > 0 :
        biblScope = etree.SubElement(imprint, "biblScope")
        biblScope.set("unit","volume")
        biblScope.text = volume#.decode("utf-8")#.strip()
    if len(nb_pages) > 0 :
        biblScope = etree.SubElement(imprint, "biblScope")
        biblScope.set("unit","pp")
        biblScope.text = nb_pages#.decode("utf-8")#.strip()
    
    date = etree.SubElement(imprint, "date")
    date.set("type","datePub")
    date.text = date_pub

    if len(doi_value) > 0 :
        doi = etree.SubElement(biblStruct, "idno")
        doi.set("type","doi")
        doi.text = doi_value

    if len(pubmed) > 0 :
        pubm = etree.SubElement(biblStruct, "idno")
        pubm.set("type","pubmed")
        pubm.text = pubmed

    # profileDesc
    profileDesc = etree.SubElement(biblFull, "profileDesc")
    langUsage = etree.SubElement(profileDesc, "langUsage")
    language = etree.SubElement(langUsage, "language")
    language.set("ident",lang_title)                     #Build from data
    textClass = etree.SubElement(profileDesc, "textClass") 
    for domain in listdomains :
        classCode = etree.SubElement(textClass, "classCode") 
        classCode.set("scheme","halDomain")
        classCode.set("n",domain)                          #Build from data
    classCode = etree.SubElement(textClass, "classCode") 
    classCode.set("scheme","halTypology")
    classCode.set("n",type_pub)

    # back 
    back = etree.SubElement(text, "back")
    listOrg = etree.SubElement(back, "listOrg")
    listOrg.set("type","structures")
    org = etree.SubElement(listOrg, "org")
    org.set("type","laboratory")
    org.set("xml_id",labo_auth_final)                                            ### ATTENTION remplacement  xml_id par xml:id


    docxml = str(etree.tostring(tei, pretty_print=True, encoding='utf-8'))

    file.write(docxml)

    file.close() 

    ## CORRECTIFS

    with open(namefile, 'r') as file :
      docxml = file.read()

    # Replace the target string
    docxml = docxml.replace("xmlns_hal=","xmlns:hal=")
    docxml = docxml.replace("xml_id=","xml:id=")
    docxml = docxml.replace("xml_lang=","xml:lang=")

    # Write the file out again
    with open(namefile, 'w') as file:
        file.write(docxml)



    headers = {
        'Packaging': 'http://purl.org/net/sword-types/AOfr',
        'Content-Type': 'text/xml',
        'On-Behalf-Of': 'login|'+login_user+';idhal|'+id_hal_user,
    }


    reponse_http = False
    response = ""

    print ("createXML bool_depot_prod ",bool_depot_prod)
    # DEPOT PREPROD
    if bool_depot_preprod == True :
        data = open(namefile)
        try :
            response = requests.post('https://api-preprod.archives-ouvertes.fr/sword/hal/', headers=headers, data=data, auth=(login_depot, passwd_depot),timeout=60)
        except requests.exceptions.RequestException as e:
            print ("ERROR REQUEST -> "+e)
        except requests.exceptions.Timeout as t :
            print ("ERROR TIMEOUT REQUEST -> "+t)
        print ("response POST : code    ",response)

    # DEPOT PROD
    if bool_depot_prod == True :
        data = open(namefile)
        try :
            response = requests.post('https://api.archives-ouvertes.fr/sword/hal/', headers=headers, data=data, auth=(login_depot, passwd_depot),timeout=60)
        except requests.exceptions.RequestException as e:
            print ("ERROR REQUEST -> "+e)
        except requests.exceptions.Timeout as t :
            print ("ERROR TIMEOUT REQUEST -> "+t)            
        print ("response POST : code    ",response)

    print ('request POST OK')
    if "202" in str(response) :
        reponse_http = True
    
    return reponse_http


####################################################################
########## END METHOD CREATE XML
##########
####################################################################


def create_single_xml(listauthors, lang_title, title_publi, name_conf, nb_pages, date_pub, listdomains, type_pub, ville, pays, pays_acr, doi_value, editor_book, volume, pubmed, name_user, labo_auth_final, id_hal_user, login_user):
    print ("method create_single_xml begin")
    data = ""

    ## VARIABLES CREATION XML

    # Recup des donnes de la liste
    namefile = "xml_files/"+str(login_user)+"temp.xml"

    file = open(namefile,"w") 
    file.write("<?xml version=\"1.0\" encoding=\"utf-8\"?>\n")


    tei = etree.Element("TEI")
    tei.set("xmlns","http://www.tei-c.org/ns/1.0")
    tei.set("xmlns_hal","http://hal.archives-ouvertes.fr/")   ### ATTENTION   remplacement xmlns_hal par xmlns:hal

    text = etree.SubElement(tei, "text")
    body = etree.SubElement(text, "body")
    listBibl = etree.SubElement(body, "listBibl")
    biblFull = etree.SubElement(listBibl, "biblFull")

    # TitleStmt
    if (type_pub == "COMM") or (type_pub == "POSTER") or  (type_pub == "ART") or (type_pub == "OUV") or  (type_pub == "COUV")  :

        titleStmt = etree.SubElement(biblFull, "titleStmt")
        title = etree.SubElement(titleStmt, "title")
        title.set("xml_lang",lang_title)          #Build from data      ### ATTENTION  remplacement xml_lang par xml:lang
        title.text = title_publi.decode("utf-8")                   #Build from data

        for auth in listauthors :
            author = etree.SubElement(titleStmt, "author")
            author.set("role","aut")
            persName = etree.SubElement(author, "persName")
            forename = etree.SubElement(persName, "forename")
            forename.set("type","first")
            forename.text = auth[1].decode("utf-8")                #Build from data
            surname = etree.SubElement(persName, "surname")
            surname.text = auth[0].decode("utf-8")                    #Build from data
            if len(auth[2]) > 1 :
                if auth[0].decode("utf-8") == name_user and id_hal_user is not "":
                    idno =  etree.SubElement(author, "idno")
                    idno.set("type", "idhal")
                    idno.text = id_hal_user
                affiliation = etree.SubElement(author, "affiliation")
                labo_author = "#"+auth[2]
                affiliation.set("ref",labo_author)             #Build from data


    # Unnecessary noteStmt
    """
    notesStmt = etree.SubElement(biblFull, "notesStmt")
    note = etree.SubElement(notesStmt, "note")
    note.set("type","commentary")
    note.text = comment_publi
    """
    # sourceDesc
    sourceDesc = etree.SubElement(biblFull, "sourceDesc")
    biblStruct = etree.SubElement(sourceDesc, "biblStruct")
    analytic = etree.SubElement(biblStruct, "analytic")
    title = etree.SubElement(analytic, "title")
    title.set("xml_lang",lang_title)          #Build from data             ### ATTENTION remplacement  xml_lang par xml:lang
    title.text = title_publi.decode("utf-8")                   #Build from data
    #print ("CREATE XML title "+str(type(title_publi)))


    for auth in listauthors :
        author = etree.SubElement(analytic, "author")
        author.set("role","aut")
        persName = etree.SubElement(author, "persName")
        forename = etree.SubElement(persName, "forename")
        forename.set("type","first")
        forename.text = auth[1].decode("utf-8")                #Build from data
        surname = etree.SubElement(persName, "surname")
        surname.text = auth[0].decode("utf-8")                    #Build from data
        if len(auth[2]) > 1 :
            affiliation = etree.SubElement(author, "affiliation")
            labo_author = "#"+auth[2]
            affiliation.set("ref",labo_author)             #Build from data
            if auth[1] == name_user:
                idno_idhal =  etree.SubElement(author, "idno")
                idno_idhal.set("type", "idhal")
                idno.text = id_hal_user



    monogr = etree.SubElement(biblStruct, "monogr")
    title = etree.SubElement(monogr, "title")
    if type_pub == "ART":
        title.set("level","j")
        title.text = name_conf.decode("utf-8")                       #Build from data
    if type_pub == "COMM":
        title.set("level","m")
        title.text = name_conf.decode("utf-8")                       #Build from data
    if type_pub == "POSTER":
        title.set("level","m")
        title.text = name_conf.decode("utf-8")    
    # Pour les COUV on donne le titre du livre (ici noté name_conf)
    if type_pub == "COUV":
        title = etree.SubElement(monogr, "title")
        title.set("level","m")
        title.text = name_conf.decode("utf-8")   # ici name_conf = titre livre                    #Build from data
        if len(editor_book) > 0 :
            editor = etree.SubElement(monogr, "editor")
            editor.text = editor_book.decode("utf-8")     #Build from data

    
    if (type_pub == "COMM") or (type_pub == "POSTER") :
        if (pays.strip() is not ""):
    
            meeting = etree.SubElement(monogr, "meeting")
            title = etree.SubElement(meeting, "title")
            title.text = name_conf.decode("utf-8")                      #Build from data

            date = etree.SubElement(meeting, "date")
            date.set("type","start")
            date.text = date_pub
            settlement = etree.SubElement(meeting, "settlement")
            settlement.text = ville.decode("utf-8")
            country = etree.SubElement(meeting, "country")
            country.set("key",pays_acr)
            country.text = pays#.decode("utf-8")
    
    imprint = etree.SubElement(monogr, "imprint")
    
    if len(volume) > 0 :
        biblScope = etree.SubElement(imprint, "biblScope")
        biblScope.set("unit","volume")
        biblScope.text = volume#.decode("utf-8")#.strip()
    if len(nb_pages) > 0 :
        biblScope = etree.SubElement(imprint, "biblScope")
        biblScope.set("unit","pp")
        biblScope.text = nb_pages#.decode("utf-8")#.strip()
    
    date = etree.SubElement(imprint, "date")
    date.set("type","datePub")
    date.text = date_pub

    if len(doi_value) > 0 :
        doi = etree.SubElement(biblStruct, "idno")
        doi.set("type","doi")
        doi.text = doi_value

    if len(pubmed) > 0 :
        pubm = etree.SubElement(biblStruct, "idno")
        pubm.set("type","pubmed")
        pubm.text = pubmed

    # profileDesc
    profileDesc = etree.SubElement(biblFull, "profileDesc")
    langUsage = etree.SubElement(profileDesc, "langUsage")
    language = etree.SubElement(langUsage, "language")
    language.set("ident",lang_title)                     #Build from data
    textClass = etree.SubElement(profileDesc, "textClass") 
    for domain in listdomains :
        classCode = etree.SubElement(textClass, "classCode") 
        classCode.set("scheme","halDomain")
        classCode.set("n",domain)                          #Build from data
    classCode = etree.SubElement(textClass, "classCode") 
    classCode.set("scheme","halTypology")
    classCode.set("n",type_pub)

    # back 
    back = etree.SubElement(text, "back")
    listOrg = etree.SubElement(back, "listOrg")
    listOrg.set("type","structures")
    org = etree.SubElement(listOrg, "org")
    org.set("type","laboratory")
    org.set("xml_id",labo_auth_final)                                            ### ATTENTION remplacement  xml_id par xml:id


    docxml = str(etree.tostring(tei, pretty_print=True, encoding='utf-8'))

    file.write(docxml) 

    file.close() 

    ## CORRECTIFS

    with open(namefile, 'r') as file :
      docxml = file.read()

    # Replace the target string
    docxml = docxml.replace("xmlns_hal=","xmlns:hal=")
    docxml = docxml.replace("xml_id=","xml:id=")
    docxml = docxml.replace("xml_lang=","xml:lang=")

    rep = ""
    # Write the file out again
    with open(namefile, 'w') as file:
        file.write(docxml)

    #print (docxml)

    return docxml



